import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import java.util.*;
import java.io.*;

/**
 *
 * @author Tvc97
 */
public class mCanvas extends GameCanvas implements Runnable {

    int w, h, fh, bh, top, last;
    Midlet m;
    Font f, b;
    SocketConnection sc;
    DataInputStream dis;
    DataOutputStream dos;
    Vector v;
    StringBuffer sb;
    String[] str;
    Graphics g;
    TextInput ti;

    public mCanvas(Midlet m) {
        super(false);
        this.m = m;
        setFullScreenMode(true);

        g = getGraphics();

        w = getWidth();
        h = getHeight();

        v = new Vector();

        f = Font.getFont(0, 0, 8);
        fh = f.getHeight();
        b = Font.getFont(0, 1, 8);
        bh = b.getHeight();
        ti = new TextInput(this);

        top = bh + fh + 16;

    }

    public void run() {
        while (true) {
            ti.animate();
            ti.update();
            draw(g);
            flushGraphics();
            try {
                Thread.sleep(25);
            } catch (Exception exc) {
            }
        }
    }

    public void draw(Graphics g) {
        g.setColor(0xffffff);
        g.fillRect(0, 0, w, h);
        g.setColor(0x27ae60);
        g.fillRect(0, 0, w, bh + 8);
        g.setColor(0xffffff);
        g.setFont(b);
        g.drawString("Nhập tên nhân vật", w / 2, 4, Graphics.HCENTER | Graphics.TOP);
        g.setFont(f);
        ti.draw(g, 1, bh + 9, w - 4, fh + 4);
        g.setClip(0, 0, w, h);
        g.setColor(0);
        g.setColor(0x27ae60);
        g.drawString("Tvc97 - http://mbvn.tk", w/2, h - fh * 2, Graphics.BOTTOM | Graphics.HCENTER);
        g.fillRect(0, h - fh - 4, w, fh + 4);
        g.setColor(0xffffff);
        g.setFont(f);
        g.drawString("Thoát", 2, h - 2, Graphics.BOTTOM | Graphics.LEFT);
        g.drawString("Ok", w / 2, h - 2, Graphics.HCENTER | Graphics.BOTTOM);
        g.drawString("Xóa", w - 2, h - 2, Graphics.BOTTOM | Graphics.RIGHT);
    }

    protected void keyPressed(int k) {
        if (k == 42) {
            ti.key(10);
        } else if (k == 35) {
            ti.upper = !ti.upper;
            ti.showMethod = true;
            ti.smc = 0;
        } else if (k >= 48 && k <= 57) {
            ti.key(k - 48);
        }
        if (k == -5) {
            m.al.setString("Tên nhân vật: " + ti.getText());
            ti.deleteAll();
            m.d.setCurrent(m.al, this);
        }
        if (k == -6) {
            m.notifyDestroyed();
        }
        if (k == -7) {
            ti.delete();
        }
        if (k >= -4 && k <= -1) {
            ti.next();
        }
        draw(g);
        flushGraphics();
        
    }

    protected void keyRepeated(int k) {
        if (k == -7) {
            ti.deleteAll();
        }
        if (k >= 48 && k <= 57 && last != k) {
            ti.addNumber(String.valueOf(k - 48));
        }
        last = k;
    }

    protected void keyReleased(int k) {
        last = 0;
    }


}
